var module_name = "high_availability";
var intervalCheckStatus = null;
var dialogo_progreso_abierto = false;

$(document).ready(function() {
        checkStatus();

        
        $( "input[type=submit], input[type=button], button" )
      .button();
     
        
        
        //jquery tabs
         $( "#tabs" ).tabs({
          collapsible: true
        });

        $( "#tabs_status" ).tabs({
                  collapsible: true
        });

        $("#error_sinc_div").dialog({
            modal: false,
            draggable: false,
            resizable: false,
            height:220,
            width:420
        });


        $("#myDialog").dialog({
            //autoOpen:true,
           height:"200",
           width:"400",
            modal: true,
            draggable: false,
            resizable: false,
            position: ['center'],
            show: 'blind',
            hide: 'blind',
            //addClass:".ui-dialog-titlebar-close"
        });

        
        
        
});

function send()
{
	$('#node2data').hide();
	$('#waiting').show();
	var ipSlave   = $('#ip_secondary_server').val();
	var passSlave = $('#slave_root_password').val();
	
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
                menu:                       module_name,
                rawmode:                    'yes',
                action:                     'connectNode2',
                ip_secondary_server:	    ipSlave,
                slave_password:	 	    passSlave
        },
        function (respuesta) {
		if(respuesta["error"]){
			$('#waiting').hide();
			$('#node2data').show();
			alert(respuesta["error"]);
		}
		else{
			if(respuesta["master"]["partitions"]){
				for(var i=0; i<respuesta["master"]["partitions"].length; i++)
					$('#primary_disk').append("<option value='"+respuesta["master"]["partitions"][i]+"'>"+respuesta["master"]["partitions"][i]+"</option>");
			}
			if(respuesta["slave"]["partitions"]){
                                for(var i=0; i<respuesta["slave"]["partitions"].length; i++)
					$('#secondary_disk').append("<option value='"+respuesta["slave"]["partitions"][i]+"'>"+respuesta["slave"]["partitions"][i]+"</option>");
                        }
			if(respuesta["master"]["network"]){
				for(inet in respuesta["master"]["network"]){
					$('#interface_name_master').append("<option value='"+inet+"'>"+respuesta["master"]["network"][inet]+"</option>");
					$('#interface_ip_floating_node1').append("<option value='"+inet+"'>"+respuesta["master"]["network"][inet]+"</option>");
				}
			}
			if(respuesta["slave"]["network"]){
				for(inet in respuesta["slave"]["network"]){
					$('#interface_name_slave').append("<option value='"+inet+"'>"+respuesta["slave"]["network"][inet]+"</option>");
					$('#interface_ip_floating_node2').append("<option value='"+inet+"'>"+respuesta["slave"]["network"][inet]+"</option>");
				}
			}
			$('#myDialog').hide();
                        $('#myDialog').dialog( "close" );
		}
	});
}


function overlay(element){
	
	el=document.getElementById(element);
	/*var e;
	var d;
	el= document.getElementById("myDialog");

	e = document.getElementById("slave_root_password").value;
		var full1 = (e == "") ? 1 : 0;
	d = document.getElementById("ip_secondary_server").value;
		var full2 = (d =="") ? 1 : 0;
	if((full1==1)&&(full2==1)){ 
		el.style.visibility = "hidden";
	}
	else{
	el.style.visibility = "visible";
	}*/
	if(el)
	     el.style.visibility = (el.style.visibility == "visible") ? "hidden" : "visible";
}

function switch_servers()
{
	overlay("ws");
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
                menu:                       module_name,
                rawmode:                    'yes',
                action:                     'switch_servers'
	},
	function (respuesta){
		mostrar_mensaje(respuesta["message"],false);
		$('#ws').hide();
	})
	.fail(function() {
		mostrar_mensaje("The servers has switched roles. Please remember always use your floating ip. You may need to log in again to see the changes.",false);
                $('#ws').hide();
	});
}

function startReplicate()
{
	var master_hostname  = $('#hostname_primary_server').val();
	var master_interface = $('#interface_name_master').val(); 
	var master_partition = $('#primary_disk').val();
	var slave_hostname   = $('#hostname_secondary_server').val();
	var slave_interface  = $('#interface_name_slave').val();
	var slave_partition  = $('#secondary_disk').val();
	var slave_ip	     = $('#ip_secondary_server').val();
	var slave_password   = $('#slave_root_password').val();
	var ip_floating      = $('#ip_floating').val();
	var int_ipf_node1    = $('#interface_ip_floating_node1').val();
	var int_ipf_node2    = $('#interface_ip_floating_node2').val();
	var auth_key	     = $('#auth_key').val();
	var directories      = $('#directories_entered').val();
	var services	     = $('#services_entered').val();


	 $.post('index.php?menu=' + module_name + '&rawmode=yes', {
                menu:                       module_name,
                rawmode:                    'yes',
                action:                     'replicate',
		interface_name_master:      master_interface,
		interface_name_slave:       slave_interface,
	        hostname_primary_server:    master_hostname,
		primary_disk:               master_partition,
		hostname_secondary_server:  slave_hostname,
		ip_secondary_server:	    slave_ip,
		secondary_disk:		    slave_partition,
		slave_root_password:	    slave_password,
		ip_floating:		    ip_floating,
	 	interface_ipf_node1:	    int_ipf_node1,
		interface_ipf_node2:	    int_ipf_node2,
		auth_key:		    auth_key,
		services_entered:	    services,
		directories_entered:	    directories
        },
        function (respuesta) {
		if(respuesta["error"])
		    mostrar_mensaje(respuesta["error"],true);
		else
		    checkStatus();
	})
	.fail(function() {
		mostrar_mensaje("Could not connect to server",true);
	});
}

function checkStatus()
{
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
                menu:                       module_name,
                rawmode:                    'yes',
                action:                     'checkStatus'
	},
	function(respuesta){
		if(respuesta["error"]){
			ocultar_dialogo_progreso();	
			mostrar_mensaje(respuesta["info"],true);
			clearInterval(intervalCheckStatus);
			intervalCheckStatus = null;
		}
		else if(respuesta["finished"]){
			ocultar_dialogo_progreso();
			clearInterval(intervalCheckStatus);
			intervalCheckStatus = null;
			location.reload();
		}
		else if(respuesta["info"])
			{
			if(!dialogo_progreso_abierto)
                      	     mostrar_dialogo_progreso();
			if(!intervalCheckStatus)
                      	     intervalCheckStatus = setInterval("checkStatus()",1000)
			$('#feedback').text(respuesta["info"]);
			$('.neo-progress-bar-title').text(respuesta["title"]);
			neo_upgrade_progress_bar(respuesta["percentage"]);
		}
		else if(respuesta["getSlaveData"]){
			//prompt("test");
			//alert("SI");
			overlay("myDialog");
			//document.getElementById("#myDialog").show();
			//x.show();
		}

	})
	.fail(function(){
		 $('#feedback').text("Moving document root files or stoping httpd service");
	});

}

function mostrar_mensaje(s, is_error)
{
        if(is_error){
           $('#neo-addons-error-message').addClass('ui-state-error');
           $('#neo-addons-error-message').removeClass('ui-state-focus');
           $('.ui-icon').addClass('ui-icon-alert');
           $('.ui-icon').removeClass('ui-icon-info');
        }
        else{
           $('#neo-addons-error-message').addClass('ui-state-focus');
           $('#neo-addons-error-message').removeClass('ui-state-error');
           $('.ui-icon').addClass('ui-icon-info');
           $('.ui-icon').removeClass('ui-icon-alert');
        }
        $('#neo-addons-error-message-text').text(s);
        $('#neo-addons-error-message').show('slow', 'linear', function() {
                setTimeout(function() {
                        $('#neo-addons-error-message').fadeOut();
                }, 100000);
        });
}


function ocultar_dialogo_progreso()
{
        $('.neo-modal-box').fadeOut(10);
        $('.neo-modal-blockmask').fadeOut(20);
        neo_upgrade_progress_bar(0);
        dialogo_progreso_abierto = false;
}

function neo_upgrade_progress_bar(percentage)
{
    $('.neo-progress-bar-percentage').css('width',percentage+'%');
    $('.neo-progress-bar-percentage-tag').html(percentage+'%');
    $('.neo-progress-bar-progress').css('width',percentage+'%');
}

function mostrar_dialogo_progreso()
{
    var maskHeight = $(document).height();
    var maskWidth = $(window).width();

    $('.neo-modal-blockmask').css({'width':maskWidth,'height':maskHeight});

    $('.neo-modal-blockmask').fadeIn(600);
    $('.neo-modal-blockmask').fadeTo("fast",0.8);

    var winH = $(window).height();
    var winW = $(window).width();

    $('.neo-modal-box').css('top',  winH/2-$('.neo-modal-box').height()/2);
    $('.neo-modal-box').css('left', winW/2-$('.neo-modal-box').width()/2);

    $('.neo-modal-box').fadeIn(2000);
    dialogo_progreso_abierto = true;
}


function add_serviceList()
{
	var service = $('#services').val();
	if(service != ''){
		$('#services').val('');
		$('#select_services').append('<option value="'+service+'">'+service+'</option>');
		var current_services =  $('#services_entered').val();
		if(current_services == '')
        		$('#services_entered').val(service);
		else
			$('#services_entered').val(current_services + "\n" + service);
	}
} 

function add_directoryList()
{
	var directory = $('#directories').val();
	if(directory != ''){
        	$('#directories').val('');
        	$('#select_directories').append('<option value="'+directory+'">'+directory+'</option>');
        	var current_directories =  $('#directories_entered').val();
        	if(current_directories == '')
                	$('#directories_entered').val(directory);
        	else
                	$('#directories_entered').val(current_directories + "\n" + directory);
	}
}

function remove_serviceList()
{
	var service = $('#select_services').val();
	if(service){
		$('#select_services option:selected').remove();
		var current_services =  $('#services_entered').val();
		var arr_services = current_services.split("\n");
		for(var i=0; i<arr_services.length; i++){
			if(arr_services[i] == service){
				arr_services.splice(i,1);
				break;
			}
		}
		var new_services = arr_services.join("\n");
		$('#services_entered').val(new_services);
	}
}

function remove_directoryList()
{
	var directory = $('#select_directories').val();
        if(directory){
                $('#select_directories option:selected').remove();
                var current_directories =  $('#directories_entered').val();
                var arr_directories = current_directories.split("\n");
                for(var i=0; i<arr_directories.length; i++){
                        if(arr_directories[i] == directory){
                                arr_directories.splice(i,1);
                                break;
                        }
                }
                var new_directories = arr_directories.join("\n");
                $('#directories_entered').val(new_directories);
        }
}
/*
/*Insertar dentro del else de arriba la función show del dialog y para que se cierre después de presionar el botón...*/
