BEGIN TRANSACTION;
CREATE TABLE directories (
  id      integer not null primary key,
  value   varchar(200)
);
CREATE TABLE services (
  id      integer not null primary key,
  value   varchar(200)
);
CREATE TABLE settings (
   id                         integer not null primary key,
   interface_name_master      varchar(20),
   interface_name_slave       varchar(20),
   hostname_primary_server    varchar(200),
   primary_disk               varchar(100),
   hostname_secondary_server  varchar(200),
   ip_secondary_server        varchar(20),
   secondary_disk             varchar(100),
   auth_key                   varchar(100),
   partition_to_mount         varchar(100),
   ip_floating                varchar(20),
   interface_ipf_node1        varchar(20),
   interface_ipf_node2	      varchar(20)
);
CREATE TABLE haStatus (
  id              integer not null primary key,
  status          varchar(500),
  iserror         integer,
  isProcessFinish integer, 
  percentage      integer
);
INSERT INTO haStatus VALUES (1,'',0,0,0);
COMMIT;
