<?php 
require_once("/var/www/html/libs/misc.lib.php");
require_once("/var/www/html/configs/default.conf.php");
require_once($arrConf['basePath']."/libs/paloSantoDB.class.php");
require_once($arrConf['basePath']."/modules/heartbeat_module/configs/default.conf.php");
require_once($arrConf['basePath']."/modules/heartbeat_module/libs/paloSantoHeartbeatModule.class.php");
require_once($arrConf['basePath']."/libs/JSON.php");

load_language($arrConf['basePath']."/");

//include lang file
$module_name = "heartbeat_module";
$lang=get_language($arrConf['basePath']."/");
$base_dir=$arrConf['basePath'];
$lang_file="modules/$module_name/lang/$lang.lang";
if (file_exists("$base_dir/$lang_file")) include_once "$base_dir/$lang_file";
else include_once "$base_dir/modules/$module_name/lang/en.lang";



global $arrConf;
global $arrConfModule;
global $arrLang;
global $arrLangModule;

$arrLang   = array_merge($arrLang,$arrLangModule);
$arrConf   = array_merge($arrConf,$arrConfModule);

$arrResponse['Response_Server'] = "";
$arrSalida = array_merge($arrResponse,$arrLang);

$action       = getParameter('action');
$service      = getParameter('service');
$directory    = getParameter('directory');

// se instancia a JSON
$json = new Services_JSON();

$id_server = 1;

if($action == "lang"){
    $arrLanJSON = $json->encode($arrSalida);
    echo $arrLanJSON;
}

if($action == "add"){

    $pDB1 = new paloDB($arrConf['dsn_conn_database']);
    $pHeartbeatModule2 = new paloSantoHeartbeatModule($pDB1);
    $server = $pHeartbeatModule2->getHeartbeatModuleById($id_server);
    

    if(is_array($server)){
        $pHeartbeatModule2->insertService($id_server,$service);
        $arrSalida['Response_Server'] = $arrLang["Service Added"];
        $arrLanJSON = $json->encode($arrSalida);
        echo $arrLanJSON;
    }
    else{
        $arrSalida['Response_Server'] = $arrLang["No data"];
        $arrLanJSON = $json->encode($arrSalida);
        echo $arrLanJSON;
    }
}
if($action == "del"){
    $pDB1 = new paloDB($arrConf['dsn_conn_database']);
    $pHeartbeatModule2 = new paloSantoHeartbeatModule($pDB1);
    if($pHeartbeatModule2->removeService($service)){
        $arrSalida['Response_Server'] = $arrLang["Services Removed"];
        $arrLanJSON = $json->encode($arrSalida);
        echo $arrLanJSON;
    }
    else{
        $arrSalida['Response_Server'] = $arrLang["Services did not remove"];
        $arrLanJSON = $json->encode($arrSalida);
        echo $arrLanJSON;
    }
}
if($action == "directory"){
    $pDB1 = new paloDB($arrConf['dsn_conn_database']);
    $pHeartbeatModule2 = new paloSantoHeartbeatModule($pDB1);
    // validar si el directorio es valido
    if(is_dir($directory)){
        // si es valido entonces verificar si el no existe el la base
        $id_service = $pHeartbeatModule2->getServiceName($service);
        $directories = $pHeartbeatModule2->getDirectoryByService($id_service);
        if(is_array($directories)){
            // verificar si existe ya en base dicho directorio
            $band = 0;
            $result = $pHeartbeatModule2->getDirectoryByService($id_service);
            foreach($result as $key=>$value){
                if($value['directory_name'] == $directory)
                    $band=1;
            }
            if($band==1){
                $arrSalida['Response_Server'] = $arrLang["Exist Directory"];
                $arrLanJSON = $json->encode($arrSalida);
                echo $arrLanJSON;
            }else{
                // si no existe en la base proceder a insertarlo en la misma
                if($pHeartbeatModule2->insertDirectory($id_service, $directory)){
                    $arrSalida['Response_Server'] = $arrLang["Directory Added"];
                    $arrLanJSON = $json->encode($arrSalida);
                    echo $arrLanJSON;
                }
                else{
                    $arrSalida['Response_Server'] = $arrLang["Directory did not add"];
                    $arrLanJSON = $json->encode($arrSalida);
                    echo $arrLanJSON;
                }
            }
        }else{
            // si no existe en la base proceder a insertarlo en la misma
            if($pHeartbeatModule2->insertDirectory($id_service, $directory)){
                $arrSalida['Response_Server'] = $arrLang["Directory Added"];
                $arrLanJSON = $json->encode($arrSalida);
                echo $arrLanJSON;
            }
            else{
                $arrSalida['Response_Server'] = $arrLang["Directory did not add"];
                $arrLanJSON = $json->encode($arrSalida);
                echo $arrLanJSON;
            }
        }
    }else{
        $arrSalida['Response_Server'] = $arrLang["Directory did not exist"];
        $arrLanJSON = $json->encode($arrSalida);
        echo $arrLanJSON;
    }

}
?>
